function highlightFrameElement(frameElement){
    var frameDocument,relatedWindow;
    var contentEl = document.getElementById('highlight-el');
    var contentElMargin = contentEl.querySelector('.highlight-element-offset__margin');
    var contentElBorder = contentEl.querySelector('.highlight-element-offset__border');
    var contentElPadding = contentEl.querySelector('.highlight-element-offset__padding');
    var contentElContent = contentEl.querySelector('.highlight-element-offset__content');
    this.draw = function(target){
        console.log("[target", target);
        var canvasOffset = frameDocument.getBoundingClientRect();
        // targetOffset
        var targetOffset = target.getBoundingClientRect();
        console.log("[canvasOffset, targetOffset]", canvasOffset, targetOffset);
        var computed = window.getComputedStyle(target,null);
        // margin
        var marginTop = Number ( computed.getPropertyValue("margin-top").replace("px","") );
        var marginLeft = Number ( computed.getPropertyValue("margin-left").replace("px","") );
        var marginRight = Number ( computed.getPropertyValue("margin-right").replace("px","") );
        var marginBottom = Number ( computed.getPropertyValue("margin-bottom").replace("px","") );
        console.log("[marginTop, marginLeft,marginRight,marginBottom ]", marginTop, marginLeft, marginRight,marginBottom );
        // border
        var borderTop = Number ( computed.getPropertyValue("border-top-width").replace("px","") );
        var borderLeft = Number ( computed.getPropertyValue("border-left-width").replace("px","") );
        var borderRight = Number ( computed.getPropertyValue("border-right-width").replace("px","") );
        var borderBottom = Number ( computed.getPropertyValue("border-bottom-width").replace("px","") );
        console.log("[borderTop, borderLeft,borderRight,borderBottom ]", borderTop, borderLeft, borderRight,borderBottom );
        // padding
        var paddingTop = Number ( computed.getPropertyValue("padding-top").replace("px","") );
        var paddingLeft = Number ( computed.getPropertyValue("padding-left").replace("px","") );
        var paddingRight = Number ( computed.getPropertyValue("padding-right").replace("px","") );
        var paddingBottom = Number ( computed.getPropertyValue("padding-bottom").replace("px","") );
        console.log("[paddingTop, paddingLeft,marginRight,marginBottom ]", paddingTop, paddingLeft, paddingRight,paddingBottom );
        // content
        var width =  ( ( target.offsetWidth || targetOffset.width ) - borderLeft - borderRight  );
        var height = ( ( target.offsetHeight || targetOffset.height ) - borderTop - borderBottom  );
        console.log("[width, height ]", width, height );
        // calculate offset
        // window top:
        var windowTop = relatedWindow.pageYOffset;
        var windowLeft = relatedWindow.pageXOffset;
        console.log("[windowTop, windowLeft ]", windowTop, windowLeft );
        var targetOffsetTop = windowTop + canvasOffset.top + targetOffset.top - marginTop;
        var targetOffsetLeft = windowLeft + canvasOffset.left + targetOffset.left - marginLeft;
        /*
        console.log("[canvasOffset.top , targetOffset.top,  windowTop]", canvasOffset.top , targetOffset.top,windowTop );
        console.log("[canvasOffset.left , targetOffset.left,  windowLeft]", canvasOffset.left , targetOffset.left,windowLeft );
        console.log("[targetOffsetTop, targetOffsetLeft ]", targetOffsetTop, targetOffsetLeft );
        */
        // margin
        contentElMargin.style.width = ( marginLeft + marginRight + target.offsetWidth )  + "px";
        contentElMargin.style.height = ( marginTop + marginBottom + target.offsetHeight ) + "px";
        // border
        contentElBorder.style.top = marginTop + "px";
        contentElBorder.style.left = marginLeft + "px";
        contentElBorder.style.width = ( borderLeft + borderRight + width)  + "px";
        contentElBorder.style.height = ( borderTop + borderBottom + height ) + "px";
        // padding
        contentElPadding.style.top = ( marginTop + borderTop ) + "px";
        contentElPadding.style.left = ( marginLeft + borderLeft ) + "px";
        contentElPadding.style.width = width  + "px";
        contentElPadding.style.height = height + "px";
        // content
        contentElContent.style.top = ( marginTop + borderTop +  paddingTop ) + "px";
        contentElContent.style.left = ( marginLeft + borderLeft + paddingLeft ) + "px";
        contentElContent.style.width =  ( width - paddingLeft - paddingRight ) + "px";
        contentElContent.style.height = ( height - paddingTop - paddingBottom )+ "px";
        // positioning element
        contentEl.style.left = targetOffsetLeft  + "px";
        contentEl.style.top = targetOffsetTop + "px";
    };
    this.drawSVG = function(target){
        var canvasOffset = frameDocument.getBoundingClientRect();
        // targetOffset
        var targetOffset = target.getBoundingClientRect();
        // content
        var width = targetOffset.width;
        var height = targetOffset.height;
        console.log("[SVG width and height]: ", width, height);
        // window top:
        var windowTop = relatedWindow.pageYOffset;
        var windowLeft = relatedWindow.pageXOffset;
        var targetOffsetTop = windowTop + canvasOffset.top + targetOffset.top;
        var targetOffsetLeft = windowLeft + canvasOffset.left + targetOffset.left;
        // margin
        contentElMargin.style.width = width  + "px";
        contentElMargin.style.height = height + "px";
        // border
        contentElBorder.style.top = "0";
        contentElBorder.style.left = "0";
        contentElBorder.style.width = "0";
        contentElBorder.style.height = "0";
        // padding
        contentElPadding.style.top = "0";
        contentElPadding.style.left = "0";
        contentElPadding.style.width = "0";
        contentElPadding.style.height = "0";
        // content
        contentElContent.style.top = "0";
        contentElContent.style.left = "0";
        contentElContent.style.width =  width + "px";
        contentElContent.style.height = height + "px";
        // positioning element
        contentEl.style.left = targetOffsetLeft  + "px";
        contentEl.style.top = targetOffsetTop + "px";
    };
    this.hide = function(){
        contentEl.style.left = '-9999px';
        contentEl.style.top = '-9999px';
    };

    /* events automatic bindings */
    var target;
    var $self = this;
    frameElement.addEventListener('load',function(){
        $self.hide();
        relatedWindow = frameElement.contentWindow;
        frameDocument = frameElement.contentDocument.documentElement;//.ownerDocument.body;
        frameDocument.addEventListener('mousemove',function(e){
            if ( target && target === e.target )
                return;
            console.log("[HIGHLIGHTING] | Moving : ", e.target);
            target = e.target;
            if( target.getBBox)
                $self.drawSVG(target);
            else
                $self.draw(target);
        });
        frameDocument.addEventListener('mouseleave',function(e){
            $self.hide();
            target = undefined;
        });
        frameDocument.addEventListener('click',function(e){
            e.preventDefault();
            console.log("[TARGET ELEMENT CLICKED]",e.target);
        });
        relatedWindow.addEventListener('scroll',function(){
            $self.hide();
        });
    });
    return this;
}